<?php
defined('BASEPATH') OR exit('No direct script access allowed');


class M_Search extends CI_Model {
		function __construct()
		{
			parent:: __construct();
			$this->db221 = $this->load->database('DB221', TRUE);
			$this->db2 = $this->load->database('DB2', TRUE);
			$this->yzdb = $this->load->database('YZDB', TRUE);
		}
		
		public function cek_data_rekam($nik = '',$no_kk = '',$nama_lgkp = '',$no_kec = 0){
			$sql = "";
			$sql .= "SELECT B.NIK,B.NO_KK, B.NAMA_LGKP, B.TMPT_LHR,TO_CHAR(B.TGL_LHR,'DD-MM-YYYY') AS TGL_LHR,CASE WHEN B.JENIS_KLMIN = 1 THEN 'LAKI-LAKI' ELSE 'PEREMPUAN' END AS JENIS_KLMIN, D.ALAMAT,  LPAD(TO_CHAR(D.NO_RT), 3, '0') AS RT,LPAD(TO_CHAR(D.NO_RW), 3, '0') AS RW,(SELECT COUNT(1) AS JML FROM CARD_MANAGEMENT@DB2 WHERE NIK = B.NIK ) AS JUMLAH_CETAK, (SELECT C.NAMA_KEC FROM SETUP_KEC C WHERE C.NO_PROP = 32 AND C.NO_KAB = 73 AND B.NO_KEC = C.NO_KEC) AS NAMA_KEC, (SELECT C.NAMA_KEL FROM SETUP_KEL C WHERE C.NO_PROP = 32 AND C.NO_KAB = 73 AND B.NO_KEC = C.NO_KEC AND B.NO_KEL = C.NO_KEL) AS NAMA_KEL, UPPER(F5_GET_REF_WNI(F5_TO_NUMBER(B.AGAMA,7), 501)) AGAMA, UPPER(F5_GET_REF_WNI(B.JENIS_PKRJN, 201)) JENIS_PKRJN, UPPER(F5_GET_REF_WNI(B.STAT_KWN, 601)) STAT_KWN, CASE WHEN A.CURRENT_STATUS_CODE IS NULL THEN '-' ELSE A.CURRENT_STATUS_CODE END AS CURRENT_STATUS_CODE, CASE WHEN F.PRINTED_BY IS NULL THEN '-' ELSE F.PRINTED_BY END AS SUKET_BY ,CASE WHEN TO_CHAR(F.PRINTED_DATE,'DD-MM-YYYY') IS NULL THEN '-' ELSE TO_CHAR(F.PRINTED_DATE,'DD-MM-YYYY') END AS SUKET_DT,CASE WHEN  TO_CHAR(G.LAST_UPDATE,'DD-MM-YYYY') IS NULL AND TO_CHAR(G.PERSONALIZED_DATE,'DD-MM-YYYY') IS NULL THEN '-' WHEN TO_CHAR(G.LAST_UPDATE,'DD-MM-YYYY') IS NULL AND TO_CHAR(G.PERSONALIZED_DATE,'DD-MM-YYYY') IS NOT NULL THEN TO_CHAR(G.PERSONALIZED_DATE,'DD-MM-YYYY') ELSE  TO_CHAR(G.LAST_UPDATE,'DD-MM-YYYY') END AS KTP_DT, CASE WHEN TO_CHAR(G.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(G.CREATED_USERNAME) IS NULL  THEN '-' WHEN TO_CHAR(G.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(G.CREATED_USERNAME) IS NOT NULL THEN TO_CHAR(G.CREATED_USERNAME) ELSE TO_CHAR(G.LAST_UPDATED_USERNAME) END AS KTP_BY, E.PATH, CASE WHEN TO_CHAR(H.REQ_DATE,'DD-MM-YYYY') IS NULL THEN '-' ELSE TO_CHAR(H.REQ_DATE,'DD-MM-YYYY') END REQ_DATE, CASE WHEN H.REQ_BY IS NULL THEN '-' ELSE H.REQ_BY END REQ_BY,CASE WHEN H.PROC_BY IS NULL THEN '-' ELSE H.PROC_BY END PROC_BY, CASE WHEN H.STEP_PROC IS NULL THEN '-' WHEN H.STEP_PROC = 'T' THEN 'Pengajuan Ditolak' WHEN H.STEP_PROC = 'A' THEN 'Masih Dalam Proses' WHEN H.STEP_PROC = 'C' THEN 'Sudah Tercetak' ELSE  H.STEP_PROC END STEP_PROC FROM BIODATA_WNI B LEFT JOIN DATA_KELUARGA D ON B.NO_KK = D.NO_KK LEFT JOIN DEMOGRAPHICS_ALL@DB2 A  ON A.NIK = B.NIK  LEFT JOIN T5_FOTO E ON A.NIK = E.NIK LEFT JOIN (SELECT NIK, PRINTED_DATE,PRINTED_BY,NO_DOKUMEN  FROM (SELECT NIK,PRINTED_DATE,PRINTED_BY,NO_DOKUMEN, RANK() OVER (PARTITION BY NIK ORDER BY PRINTED_DATE,NO_DOKUMEN DESC) RNK FROM T7_HIST_SUKET)  WHERE RNK = 1) F ON F.NIK = B.NIK LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME,LAST_UPDATE FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME,LAST_UPDATE, RANK() OVER (PARTITION BY NIK ORDER BY PERSONALIZED_DATE DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) G ON G.NIK =B.NIK LEFT JOIN (SELECT NIK,REQ_DATE,REQ_BY,PROC_DATE,PROC_BY,STEP_PROC FROM (SELECT NIK,REQ_DATE,REQ_BY,PROC_DATE,PROC_BY,STEP_PROC, RANK() OVER (PARTITION BY NIK ORDER BY REQ_DATE,ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP) WHERE RNK = 1) H ON H.NIK =B.NIK WHERE 1=1 
				AND (B.FLAG_STATUS = '0' OR (B.FLAG_STATUS = '2' AND B.FLAG_PINDAH IN(1,2,3))) ";
			if($no_kec != 0 && ($nama_lgkp != '' || $nama_lgkp != null || !empty($nama_lgkp))){ 
				$sql .= " AND B.NO_KEC = $no_kec ";
			} 
			if($nik != '' || $nik != null || !empty($nik)){ 
				if(strlen($nik) <= 17){
				$sql .= " AND B.NIK = $nik ";	
				}else{
				$sql .= " AND B.NIK IN ($nik) ";	
				}
				
			} 
			if($no_kk != '' || $no_kk != null || !empty($no_kk)){ 
				if(strlen($no_kk) <= 17){
				$sql .= " AND B.NO_KK = $no_kk ";
				}else{
				$sql .= " AND B.NO_KK IN ($no_kk) ";
				}
			}
			if($nama_lgkp != '' || $nama_lgkp != null || !empty($nama_lgkp)){ 
				$sql .= " AND B.NAMA_LGKP LIKE UPPER('$nama_lgkp') ";
			} 
			$sql .= " ORDER BY B.NO_KK, B.STAT_HBKEL ";
			$q = $this->db->query($sql);
			return $q->result();
		}
		public function cek_count_rekam($nik = '',$no_kk = '',$nama_lgkp = '',$no_kec= 0){
			$sql = "";
			$sql .= "SELECT COUNT(1) AS JML FROM BIODATA_WNI B WHERE 1=1 			
					AND (B.FLAG_STATUS = '0' OR (B.FLAG_STATUS = '2' AND B.FLAG_PINDAH IN(1,2,3))) ";
			if($no_kec != 0 && ($nama_lgkp != '' || $nama_lgkp != null || !empty($nama_lgkp))){ 
				$sql .= " AND B.NO_KEC = $no_kec ";
			} 
			if($nik != '' || $nik != null || !empty($nik)){ 
				$sql .= " AND B.NIK IN ($nik) ";
			} 
			if($no_kk != '' || $no_kk != null || !empty($no_kk)){ 
				$sql .= " AND B.NO_KK IN ($no_kk) ";
			}
			if($nama_lgkp != '' || $nama_lgkp != null || !empty($nama_lgkp)){ 
				$sql .= " AND B.NAMA_LGKP LIKE '$nama_lgkp' ";
			} 
			$sql .= " ORDER BY B.NO_KK, B.STAT_HBKEL ";
			$q = $this->db->query($sql);
			return $q->row(0)->JML;
		}
		public function export_data_rekam($nik = ''){
			$sql = "";
			$sql .= "SELECT B.NIK,B.NO_KK, B.NAMA_LGKP, B.TMPT_LHR,TO_CHAR(B.TGL_LHR,'DD-MM-YYYY') AS TGL_LHR,CASE WHEN B.JENIS_KLMIN = 1 THEN 'LAKI-LAKI' ELSE 'PEREMPUAN' END AS JENIS_KLMIN, D.ALAMAT,  LPAD(TO_CHAR(D.NO_RT), 3, '0') AS RT,LPAD(TO_CHAR(D.NO_RW), 3, '0') AS RW,(SELECT COUNT(1) AS JML FROM CARD_MANAGEMENT@DB2 WHERE NIK = B.NIK ) AS JUMLAH_CETAK, (SELECT C.NAMA_KEC FROM SETUP_KEC C WHERE C.NO_PROP = 32 AND C.NO_KAB = 73 AND B.NO_KEC = C.NO_KEC) AS NAMA_KEC, (SELECT C.NAMA_KEL FROM SETUP_KEL C WHERE C.NO_PROP = 32 AND C.NO_KAB = 73 AND B.NO_KEC = C.NO_KEC AND B.NO_KEL = C.NO_KEL) AS NAMA_KEL, UPPER(F5_GET_REF_WNI(F5_TO_NUMBER(B.AGAMA,7), 501)) AGAMA, UPPER(F5_GET_REF_WNI(B.JENIS_PKRJN, 201)) JENIS_PKRJN, UPPER(F5_GET_REF_WNI(B.STAT_KWN, 601)) STAT_KWN, CASE WHEN A.CURRENT_STATUS_CODE IS NULL THEN '-' ELSE A.CURRENT_STATUS_CODE END AS CURRENT_STATUS_CODE, CASE WHEN F.PRINTED_BY IS NULL THEN '-' ELSE F.PRINTED_BY END AS SUKET_BY ,CASE WHEN TO_CHAR(F.PRINTED_DATE,'DD-MM-YYYY') IS NULL THEN '-' ELSE TO_CHAR(F.PRINTED_DATE,'DD-MM-YYYY') END AS SUKET_DT,CASE WHEN  TO_CHAR(G.LAST_UPDATE,'DD-MM-YYYY') IS NULL AND TO_CHAR(G.PERSONALIZED_DATE,'DD-MM-YYYY') IS NULL THEN '-' WHEN TO_CHAR(G.LAST_UPDATE,'DD-MM-YYYY') IS NULL AND TO_CHAR(G.PERSONALIZED_DATE,'DD-MM-YYYY') IS NOT NULL THEN TO_CHAR(G.PERSONALIZED_DATE,'DD-MM-YYYY') ELSE  TO_CHAR(G.LAST_UPDATE,'DD-MM-YYYY') END AS KTP_DT, CASE WHEN TO_CHAR(G.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(G.CREATED_USERNAME) IS NULL  THEN '-' WHEN TO_CHAR(G.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(G.CREATED_USERNAME) IS NOT NULL THEN TO_CHAR(G.CREATED_USERNAME) ELSE TO_CHAR(G.LAST_UPDATED_USERNAME) END AS KTP_BY, E.PATH, CASE WHEN TO_CHAR(H.REQ_DATE,'DD-MM-YYYY') IS NULL THEN '-' ELSE TO_CHAR(H.REQ_DATE,'DD-MM-YYYY') END REQ_DATE, CASE WHEN H.REQ_BY IS NULL THEN '-' ELSE H.REQ_BY END REQ_BY,CASE WHEN H.PROC_BY IS NULL THEN '-' ELSE H.PROC_BY END PROC_BY, CASE WHEN H.STEP_PROC IS NULL THEN '-' WHEN H.STEP_PROC = 'T' THEN 'Pengajuan Ditolak' WHEN H.STEP_PROC = 'A' THEN 'Masih Dalam Proses' WHEN H.STEP_PROC = 'C' THEN 'Sudah Tercetak' ELSE  H.STEP_PROC END STEP_PROC FROM BIODATA_WNI B LEFT JOIN DATA_KELUARGA D ON B.NO_KK = D.NO_KK LEFT JOIN DEMOGRAPHICS_ALL@DB2 A  ON A.NIK = B.NIK  LEFT JOIN T5_FOTO E ON A.NIK = E.NIK LEFT JOIN (SELECT NIK, PRINTED_DATE,PRINTED_BY,NO_DOKUMEN  FROM (SELECT NIK,PRINTED_DATE,PRINTED_BY,NO_DOKUMEN, RANK() OVER (PARTITION BY NIK ORDER BY PRINTED_DATE,NO_DOKUMEN DESC) RNK FROM T7_HIST_SUKET)  WHERE RNK = 1) F ON F.NIK = B.NIK LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME,LAST_UPDATE FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME,LAST_UPDATE, RANK() OVER (PARTITION BY NIK ORDER BY PERSONALIZED_DATE DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) G ON G.NIK =B.NIK LEFT JOIN (SELECT NIK,REQ_DATE,REQ_BY,PROC_DATE,PROC_BY,STEP_PROC FROM (SELECT NIK,REQ_DATE,REQ_BY,PROC_DATE,PROC_BY,STEP_PROC, RANK() OVER (PARTITION BY NIK ORDER BY REQ_DATE,ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP) WHERE RNK = 1) H ON H.NIK =B.NIK WHERE 1=1 
				AND (B.FLAG_STATUS = '0' OR (B.FLAG_STATUS = '2' AND B.FLAG_PINDAH IN(1,2,3))) ";
			if($nik != '' || $nik != null || !empty($nik)){ 
				$sql .= " AND B.NIK IN ($nik) ";
			} 
			$sql .= " ORDER BY B.NO_KEC, B.NO_KEL, B.NO_KK, D.NO_RW, D.NO_RT, B.STAT_HBKEL ";
			$q = $this->db->query($sql);
			return $q->result();
		}
		public function cek_data_history($nik = '',$no_kec= 0){
			$sql = "";
			$sql .= "SELECT A.NIK, A.NO_KK, A.NAMA_LGKP, B.CHIP_ID, TO_CHAR(B.PERSONALIZED_DATE,'DD-MM-YYYY') AS KTP_DT, B.CREATED_USERNAME AS KTP_BY
			, CASE WHEN TO_CHAR(B.LAST_UPDATE,'DD-MM-YYYY') IS NULL THEN '-' ELSE TO_CHAR(B.LAST_UPDATE,'DD-MM-YYYY') END AS UPDATED_DT
			, CASE WHEN B.LAST_UPDATED_USERNAME IS NULL THEN NULL ELSE B.LAST_UPDATED_USERNAME END AS UPDATED_BY
			,F5_GET_NAMA_KECAMATAN(A.NO_PROP,A.NO_KAB,A.NO_KEC) NAMA_KEC, F5_GET_NAMA_KELURAHAN(A.NO_PROP,A.NO_KAB,A.NO_KEC,A.NO_KEL) NAMA_KEL FROM BIODATA_WNI A INNER JOIN CARD_MANAGEMENT@DB2 B ON A.NIK = B.NIK WHERE 1=1 AND (A.TGL_LHR<=ADD_MONTHS(SYSDATE,-12*17) OR A.STAT_KWN<>1) AND (A.FLAG_STATUS = '0' OR (A.FLAG_STATUS = '2' AND A.FLAG_PINDAH IN(1,2,3))) ";
			if($no_kec != 0 ){ 
				$sql .= " AND A.NO_KEC = $no_kec ";
			} 
			$sql .= " AND A.NIK IN ($nik) ORDER BY B.PERSONALIZED_DATE DESC";
			$q = $this->db->query($sql);
			return $q->result();
		}
		public function cek_count_history($nik = ''){
			$sql = "";
			$sql .= "SELECT COUNT(1) AS JML FROM BIODATA_WNI A INNER JOIN CARD_MANAGEMENT@DB2 B ON A.NIK = B.NIK WHERE 1=1 AND (A.TGL_LHR<=ADD_MONTHS(SYSDATE,-12*17) OR A.STAT_KWN<>1) AND (A.FLAG_STATUS = '0' OR (A.FLAG_STATUS = '2' AND A.FLAG_PINDAH IN(1,2,3))) AND A.NIK IN ($nik)";
			$q = $this->db->query($sql);
			return $q->row(0)->JML;
		}
		public function push_demogh221($NIK){
			$sql = "UPDATE DEMOGRAPHICS A SET A.CURRENT_STATUS_CODE = 'BIO_CAPTURED' WHERE A.CURRENT_STATUS_CODE IN (SELECT CODE FROM STATUS_ID WHERE ID_STATUS IN (3,4,5,6,7,8,9,10,11,12)) AND A.NIK IN ($NIK) AND EXISTS (SELECT 1 FROM BIODATA_WNI@DB222 B WHERE A.NIK = B.NIK)";
			$q = $this->db221->query($sql);
			return $q;
		}
		public function push_demogh2($NIK){
			$sql = "UPDATE DEMOGRAPHICS A SET A.CURRENT_STATUS_CODE = 'BIO_CAPTURED' WHERE A.CURRENT_STATUS_CODE IN (SELECT CODE FROM STATUS_ID WHERE ID_STATUS IN (3,4,5,6,7,8,9,10,11,12)) AND A.NIK IN ($NIK) AND EXISTS (SELECT 1 FROM BIODATA_WNI@DB222 B WHERE A.NIK = B.NIK)";
			$q = $this->db2->query($sql);
			return $q;
		}
		public function push_demoghall($NIK){
			$sql = "UPDATE DEMOGRAPHICS_ALL A SET A.CURRENT_STATUS_CODE = 'BIO_CAPTURED' WHERE A.CURRENT_STATUS_CODE IN (SELECT CODE FROM STATUS_ID WHERE ID_STATUS IN (3,4,5,6,7,8,9,10,11,12)) AND A.NIK IN ($NIK) AND EXISTS (SELECT 1 FROM BIODATA_WNI@DB222 B WHERE A.NIK = B.NIK)";
			$q = $this->db2->query($sql);
			return $q;
		}
		
		public function cek_data_duplicate($NIK){
			$sql = "SELECT  A.NIK
					, A.NO_PROP
					, A.NAMA_PROP
					, A.NO_KAB
					, A.NAMA_KAB
					, A.NO_KEC
					, A.NAMA_KEC
					, A.NO_KEL
					, A.NAMA_KEL
					, A.NAMA_LGKP
					, A.ALAMAT
					, A.CURRENT_STATUS_CODE
					, A.TGL_REKAM
					, A.NIK_SINGLE
					, A.NO_PROP_SINGLE
					, A.NAMA_PROP_SINGLE
					, A.NO_KAB_SINGLE
					, A.NAMA_KAB_SINGLE
					, A.NO_KEC_SINGLE
					, A.NAMA_KEC_SINGLE
					, A.NO_KEL_SINGLE
					, A.NAMA_KEL_SINGLE
					, A.NAMA_LGKP_SINGLE
					, A.ALAMAT_SINGLE
					, A.CURRENT_STATUS_CODE_SINGLE
					, A.TGL_REKAM_SINGLE FROM (SELECT  A.NIK
					, A.NO_PROP
					, (SELECT C.NAMA_PROP FROM SETUP_PROP C WHERE A.NO_PROP = C.NO_PROP) NAMA_PROP
					, A.NO_KAB
					, (SELECT C.NAMA_KAB FROM SETUP_KAB C WHERE A.NO_PROP = C.NO_PROP AND A.NO_KAB = C.NO_KAB) NAMA_KAB
					, A.NO_KEC
					, (SELECT C.NAMA_KEC FROM SETUP_KEC C WHERE A.NO_PROP = C.NO_PROP AND A.NO_KAB = C.NO_KAB AND A.NO_KEC = C.NO_KEC) NAMA_KEC
					, '0' NO_KEL
					, '-' NAMA_KEL
					, A.NAMA_LGKP
					, '-' ALAMAT
					, A.CURRENT_STATUS_CODE
					, TO_CHAR(A.TGL_REKAM,'DD-MM-YYYY') TGL_REKAM
					, TO_CHAR(A.NIK_SINGLE) NIK_SINGLE
					, TO_CHAR(A.NO_PROP_SINGLE) NO_PROP_SINGLE
					, (SELECT C.NAMA_PROP FROM SETUP_PROP C WHERE A.NO_PROP_SINGLE = C.NO_PROP) NAMA_PROP_SINGLE
					, TO_CHAR(A.NO_KAB_SINGLE) NO_KAB_SINGLE
					, (SELECT C.NAMA_KAB FROM SETUP_KAB C WHERE A.NO_PROP_SINGLE = C.NO_PROP AND A.NO_KAB_SINGLE = C.NO_KAB) NAMA_KAB_SINGLE
					, TO_CHAR(A.NO_KEC_SINGLE) NO_KEC_SINGLE
					, (SELECT C.NAMA_KEC FROM SETUP_KEC C WHERE A.NO_PROP_SINGLE = C.NO_PROP AND A.NO_KAB_SINGLE = C.NO_KAB AND A.NO_KEC_SINGLE = C.NO_KEC) NAMA_KEC_SINGLE
					, '0' NO_KEL_SINGLE
					, '-' NAMA_KEL_SINGLE
					, A.NAMA_LGKP_SINGLE
					, '-' ALAMAT_SINGLE
					, A.CURRENT_STATUS_CODE_SINGLE
					, TO_CHAR(A.TGL_REKAM_SINGLE,'DD-MM-YYYY') TGL_REKAM_SINGLE
          			FROM SIAK_DUPLICATE_FULL A
                UNION ALL
                SELECT  B.NIK
					, B.NO_PROP
					, B.NAMA_PROP
					, B.NO_KAB
					, B.NAMA_KAB
					, B.NO_KEC
					, B.NAMA_KEC
					, B.NO_KEL
					, B.NAMA_KEL
					, B.NAMA_LGKP
					, B.ALAMAT
					, B.CURRENT_STATUS_CODE
					, B.TGL_REKAM
					, B.NIK_SINGLE
					, B.NO_PROP_SINGLE
					, B.NAMA_PROP_SINGLE
					, B.NO_KAB_SINGLE
					, B.NAMA_KAB_SINGLE
					, B.NO_KEC_SINGLE
					, B.NAMA_KEC_SINGLE
					, B.NO_KEL_SINGLE
					, B.NAMA_KEL_SINGLE
					, B.NAMA_LGKP_SINGLE
					, B.ALAMAT_SINGLE
					, B.CURRENT_STATUS_CODE_SINGLE
					, B.TGL_REKAM_SINGLE FROM (SELECT  B.NIK
					, B.NO_PROP
					, (SELECT C.NAMA_PROP FROM SETUP_PROP C WHERE B.NO_PROP = C.NO_PROP) NAMA_PROP
					, B.NO_KAB
					, (SELECT C.NAMA_KAB FROM SETUP_KAB C WHERE B.NO_PROP = C.NO_PROP AND B.NO_KAB = C.NO_KAB) NAMA_KAB
					, B.NO_KEC
					, (SELECT C.NAMA_KEC FROM SETUP_KEC C WHERE B.NO_PROP = C.NO_PROP AND B.NO_KAB = C.NO_KAB AND B.NO_KEC = C.NO_KEC) NAMA_KEC
					, '0' NO_KEL
					, '-' NAMA_KEL
					, B.NAMA_LGKP
					, '-' ALAMAT
					, B.CURRENT_STATUS_CODE
					, TO_CHAR(B.CREATED,'DD-MM-YYYY') TGL_REKAM
					, TO_CHAR(C.DUPLICATE_NIK) NIK_SINGLE
					, '0' NO_PROP_SINGLE
					, '-' NAMA_PROP_SINGLE
					, '0' NO_KAB_SINGLE
					, '-' NAMA_KAB_SINGLE
					, '0' NO_KEC_SINGLE
					, '-' NAMA_KEC_SINGLE
					, '0' NO_KEL_SINGLE
					, '-' NAMA_KEL_SINGLE
					, '-' NAMA_LGKP_SINGLE
					, '-' ALAMAT_SINGLE
					, '-' CURRENT_STATUS_CODE_SINGLE
					, '-' TGL_REKAM_SINGLE 
          FROM DEMOGRAPHICS@DB221 B INNER JOIN  DUPLICATE_RESULTS@DB221 C ON B.NIK = C.NIK WHERE 
          (B.NIK IN ($NIK)) AND NOT EXISTS (SELECT 1 FROM SIAK_DUPLICATE_FULL A WHERE A.NIK = B.NIK)) B
                ) A
                WHERE A.NIK IN ($NIK) OR A.NIK_SINGLE IN ($NIK)";
			$q = $this->yzdb->query($sql);
			return $q->result();
		}
		public function cek_count_duplicate($NIK){
			$sql = "SELECT COUNT(1) JML FROM SIAK_DUPLICATE_FULL A WHERE A.NIK IN ($NIK) OR A.NIK_SINGLE IN ($NIK)";
			$q = $this->yzdb->query($sql);
			return $q->row(0)->JML;
		}		

		public function del_req($nik,$no_kec){
			$sql = "";
			$sql .= "SELECT 
					X.NO_KEC
					,X.NIK
					,X.NAMA_LGKP AS NAMA_LENGKAP
					,CASE WHEN B.CURRENT_STATUS_CODE IS NULL THEN '-' ELSE B.CURRENT_STATUS_CODE END AS CURRENT_STATUS_CODE
					,TO_CHAR(A.REQ_DATE,'YYYY-MM-DD') AS REQ_DATE
					,A.REQ_BY
					, CASE WHEN A.STEP_PROC = 'T' THEN 'DITOLAK' WHEN A.STEP_PROC = 'C' THEN 'DICETAK' ELSE 'PROSSESS' END AS STATUS_PENGAJUAN
					, CASE WHEN A.STEP_PROC = 'T' THEN UPPER(A.PROC_BY) WHEN A.STEP_PROC = 'C' THEN 'SUDAH DICATAK' ELSE '-' END AS KETERANGAN_STATUS
					, TO_CHAR(C.PERSONALIZED_DATE,'YYYY-MM-DD') AS PRINTED_DATE
					, CASE WHEN TO_CHAR(C.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(C.CREATED_USERNAME) IS NULL  THEN '-' WHEN TO_CHAR(C.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(C.CREATED_USERNAME) IS NOT NULL THEN TO_CHAR(C.CREATED_USERNAME) ELSE TO_CHAR(C.LAST_UPDATED_USERNAME) END AS PRINTED_BY
					, (SELECT C.NAMA_KEC FROM SETUP_KEC C WHERE C.NO_PROP = 32 AND C.NO_KAB = 73 AND X.NO_KEC = C.NO_KEC) AS NAMA_KEC
					, (SELECT C.NAMA_KEL FROM SETUP_KEL C WHERE C.NO_PROP = 32 AND C.NO_KAB = 73 AND X.NO_KEC = C.NO_KEC AND X.NO_KEL = C.NO_KEL) AS NAMA_KEL
					, UPPER(F5_GET_REF_WNI(X.JENIS_PKRJN, 201)) JENIS_PKRJN
					, UPPER(F5_GET_REF_WNI(X.STAT_KWN, 601)) STAT_KWN
					FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY,STEP_PROC,PROC_BY FROM 
					(SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY,STEP_PROC,PROC_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP WHERE STEP_PROC <> 'C') WHERE RNK = 1) A ON A.NIK =X.NIK
					LEFT JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY CREATED DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (TO_DATE(A.REQ_DATE,'DD-MM-YYYY') > TO_DATE(C.PERSONALIZED_DATE,'DD-MM-YYYY') OR C.PERSONALIZED_DATE IS NULL) ";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= "ORDER BY C.PERSONALIZED_DATE";
			$q = $this->db->query($sql);
			return $q->result();
		}
		public function do_delete($nik){
			$sql = "DELETE FROM T5_REQ_CETAK_KTP WHERE STEP_PROC <> 'C' AND NIK IN ($nik) ";
			$q = $this->db->query($sql);
		}
		public function cek_req_data_uktp($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT 
					X.NO_KEC
					,X.NIK
					,X.NAMA_LGKP AS NAMA_LENGKAP
					,CASE WHEN B.CURRENT_STATUS_CODE IS NULL THEN '-' ELSE B.CURRENT_STATUS_CODE END AS CURRENT_STATUS_CODE
					,TO_CHAR(A.REQ_DATE,'YYYY-MM-DD') AS REQ_DATE
					,A.REQ_BY
					, CASE WHEN A.STEP_PROC = 'T' THEN 'DITOLAK' WHEN A.STEP_PROC = 'C' THEN 'DICETAK' ELSE 'PROSSESS' END AS STATUS_PENGAJUAN
					, CASE WHEN A.STEP_PROC = 'T' THEN UPPER(A.PROC_BY) WHEN A.STEP_PROC = 'C' THEN 'SUDAH DICATAK' ELSE '-' END AS KETERANGAN_STATUS
					, TO_CHAR(C.PERSONALIZED_DATE,'YYYY-MM-DD') AS PRINTED_DATE
					, CASE WHEN TO_CHAR(C.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(C.CREATED_USERNAME) IS NULL  THEN '-' WHEN TO_CHAR(C.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(C.CREATED_USERNAME) IS NOT NULL THEN TO_CHAR(C.CREATED_USERNAME) ELSE TO_CHAR(C.LAST_UPDATED_USERNAME) END AS PRINTED_BY
					, (SELECT C.NAMA_KEC FROM SETUP_KEC C WHERE C.NO_PROP = 32 AND C.NO_KAB = 73 AND X.NO_KEC = C.NO_KEC) AS NAMA_KEC
					, (SELECT C.NAMA_KEL FROM SETUP_KEL C WHERE C.NO_PROP = 32 AND C.NO_KAB = 73 AND X.NO_KEC = C.NO_KEC AND X.NO_KEL = C.NO_KEL) AS NAMA_KEL
					, UPPER(F5_GET_REF_WNI(F5_TO_NUMBER(X.AGAMA,7), 501)) AGAMA
					, UPPER(F5_GET_REF_WNI(X.JENIS_PKRJN, 201)) JENIS_PKRJN
					, UPPER(F5_GET_REF_WNI(X.STAT_KWN, 601)) STAT_KWN
					FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY,STEP_PROC,PROC_BY FROM 
					(SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY,STEP_PROC,PROC_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP WHERE STEP_PROC <> 'C') WHERE RNK = 1) A ON A.NIK =X.NIK
					LEFT JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY CREATED DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (TO_DATE(A.REQ_DATE,'DD-MM-YYYY') > TO_DATE(C.PERSONALIZED_DATE,'DD-MM-YYYY') OR C.PERSONALIZED_DATE IS NULL) ";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1 ORDER BY C.PERSONALIZED_DATE";
			$q = $this->db->query($sql);
			return $q->result();
		}
		public function cek_req_count_uktp($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT COUNT(X.NIK) AS JML FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY,STEP_PROC,PROC_BY FROM  
					(SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY,STEP_PROC,PROC_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP WHERE STEP_PROC <> 'C') WHERE RNK = 1) A ON A.NIK =X.NIK
					LEFT JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY CREATED DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (TO_DATE(A.REQ_DATE,'DD-MM-YYYY') > TO_DATE(C.PERSONALIZED_DATE,'DD-MM-YYYY') OR C.PERSONALIZED_DATE IS NULL)";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->db->query($sql);
			return $q->row(0)->JML;
		}

		public function cek_req_data_dktp($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT X.NO_KEC,X.NIK,X.NAMA_LGKP AS NAMA_LENGKAP,B.CURRENT_STATUS_CODE,TO_CHAR(A.REQ_DATE,'DD-MM-YYYY') AS REQ_DATE,A.REQ_BY, TO_CHAR(C.PERSONALIZED_DATE,'DD-MM-YYYY') AS PRINTED_DATE,TO_CHAR(C.PERSONALIZED_DATE,'DD-MM-YYYY') AS PRINTED_DATE,CASE WHEN TO_CHAR(C.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(C.CREATED_USERNAME) IS NULL  THEN '-' WHEN TO_CHAR(C.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(C.CREATED_USERNAME) IS NOT NULL THEN TO_CHAR(C.CREATED_USERNAME) ELSE TO_CHAR(C.LAST_UPDATED_USERNAME) END AS PRINTED_BY, F5_GET_NAMA_KECAMATAN(A.NO_PROP,A.NO_KAB,A.NO_KEC) NAMA_KEC, F5_GET_NAMA_KELURAHAN(A.NO_PROP,A.NO_KAB,A.NO_KEC,A.NO_KEL) NAMA_KEL, UPPER(F5_GET_REF_WNI(F5_TO_NUMBER(X.AGAMA,7), 501)) AGAMA, UPPER(F5_GET_REF_WNI(X.JENIS_PKRJN, 201)) JENIS_PKRJN, UPPER(F5_GET_REF_WNI(X.STAT_KWN, 601)) STAT_KWN FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP  WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK LEFT JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY PERSONALIZED_DATE DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1  AND (A.REQ_DATE < C.PERSONALIZED_DATE) ";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->db->query($sql);
			return $q->result();
		}

		public function cek_req_count_dktp($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT COUNT(X.NIK) AS JML FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP  WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK LEFT JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY PERSONALIZED_DATE DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (A.REQ_DATE < C.PERSONALIZED_DATE)";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->db->query($sql);
			return $q->row(0)->JML;
		}

		public function cek_req_data_uktp_f($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT X.NO_KEC,X.NIK,X.NAMA_LGKP AS NAMA_LENGKAP,CASE WHEN B.CURRENT_STATUS_CODE IS NULL THEN '-' ELSE B.CURRENT_STATUS_CODE END AS CURRENT_STATUS_CODE,TO_CHAR(A.REQ_DATE,'YYYY-MM-DD') AS REQ_DATE,A.REQ_BY, TO_CHAR(C.PERSONALIZED_DATE,'YYYY-MM-DD') AS PRINTED_DATE,CASE WHEN TO_CHAR(C.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(C.CREATED_USERNAME) IS NULL  THEN '-' WHEN TO_CHAR(C.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(C.CREATED_USERNAME) IS NOT NULL THEN TO_CHAR(C.CREATED_USERNAME) ELSE TO_CHAR(C.LAST_UPDATED_USERNAME) END AS PRINTED_BY, F5_GET_NAMA_KECAMATAN(X.NO_PROP,X.NO_KAB,X.NO_KEC) NAMA_KEC, F5_GET_NAMA_KELURAHAN(X.NO_PROP,X.NO_KAB,X.NO_KEC,X.NO_KEL) NAMA_KEL, UPPER(F5_GET_REF_WNI(F5_TO_NUMBER(X.AGAMA,7), 501)) AGAMA, UPPER(F5_GET_REF_WNI(X.JENIS_PKRJN, 201)) JENIS_PKRJN, UPPER(F5_GET_REF_WNI(X.STAT_KWN, 601)) STAT_KWN FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP  WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK LEFT JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY CREATED DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (B.CURRENT_STATUS_CODE LIKE '%CARD%' OR B.CURRENT_STATUS_CODE LIKE '%PRINT%') AND (TO_DATE(A.REQ_DATE,'DD-MM-YYYY') > TO_DATE(C.PERSONALIZED_DATE,'DD-MM-YYYY') OR C.PERSONALIZED_DATE IS NULL)";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
		
			$q = $this->db->query($sql);
			return $q->result();
		}

		public function cek_req_count_uktp_f($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT COUNT(X.NIK) AS JML FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP  WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK LEFT JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY PERSONALIZED_DATE DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (B.CURRENT_STATUS_CODE LIKE '%CARD%' OR B.CURRENT_STATUS_CODE LIKE '%PRINT%') AND (TO_DATE(A.REQ_DATE,'DD-MM-YYYY') > TO_DATE(C.PERSONALIZED_DATE,'DD-MM-YYYY') OR C.PERSONALIZED_DATE IS NULL)";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->db->query($sql);
			return $q->row(0)->JML;
		}

		public function cek_req_data_dktp_f($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT X.NO_KEC,X.NIK,X.NAMA_LGKP AS NAMA_LENGKAP,B.CURRENT_STATUS_CODE,TO_CHAR(A.REQ_DATE,'DD-MM-YYYY') AS REQ_DATE,A.REQ_BY, TO_CHAR(C.PERSONALIZED_DATE,'DD-MM-YYYY') AS PRINTED_DATE,TO_CHAR(C.PERSONALIZED_DATE,'DD-MM-YYYY') AS PRINTED_DATE,CASE WHEN TO_CHAR(C.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(C.CREATED_USERNAME) IS NULL  THEN '-' WHEN TO_CHAR(C.LAST_UPDATED_USERNAME) IS NULL AND TO_CHAR(C.CREATED_USERNAME) IS NOT NULL THEN TO_CHAR(C.CREATED_USERNAME) ELSE TO_CHAR(C.LAST_UPDATED_USERNAME) END AS PRINTED_BY, F5_GET_NAMA_KECAMATAN(X.NO_PROP,X.NO_KAB,X.NO_KEC) NAMA_KEC, F5_GET_NAMA_KELURAHAN(X.NO_PROP,X.NO_KAB,X.NO_KEC,X.NO_KEL) NAMA_KEL, UPPER(F5_GET_REF_WNI(F5_TO_NUMBER(X.AGAMA,7), 501)) AGAMA, UPPER(F5_GET_REF_WNI(X.JENIS_PKRJN, 201)) JENIS_PKRJN, UPPER(F5_GET_REF_WNI(X.STAT_KWN, 601)) STAT_KWN FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP  WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK LEFT JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME,LAST_UPDATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY PERSONALIZED_DATE DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1  AND (B.CURRENT_STATUS_CODE LIKE '%CARD%' OR B.CURRENT_STATUS_CODE LIKE '%PRINT%') AND (A.REQ_DATE < C.PERSONALIZED_DATE)";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->db->query($sql);
			return $q->result();
		}

		public function cek_req_count_dktp_f($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT COUNT(X.NIK) AS JML FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP  WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK LEFT JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME FROM (SELECT NIK,PERSONALIZED_DATE,CREATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY PERSONALIZED_DATE DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (B.CURRENT_STATUS_CODE LIKE '%CARD%' OR B.CURRENT_STATUS_CODE LIKE '%PRINT%') AND (A.REQ_DATE < C.PERSONALIZED_DATE)";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->db->query($sql);
			return $q->row(0)->JML;
		}

		public function cek_req_data_usuket($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT X.NO_KEC,X.NIK,X.NAMA_LGKP AS NAMA_LENGKAP,B.CURRENT_STATUS_CODE,TO_CHAR(A.REQ_DATE,'DD-MM-YYYY') AS REQ_DATE,A.REQ_BY, TO_CHAR(C.PRINTED_DATE,'DD-MM-YYYY') AS PRINTED_DATE,C.PRINTED_BY, F5_GET_NAMA_KECAMATAN(A.NO_PROP,A.NO_KAB,A.NO_KEC) NAMA_KEC, F5_GET_NAMA_KELURAHAN(A.NO_PROP,A.NO_KAB,A.NO_KEC,A.NO_KEL) NAMA_KEL, UPPER(F5_GET_REF_WNI(X.JENIS_PKRJN, 201)) JENIS_PKRJN, UPPER(F5_GET_REF_WNI(X.STAT_KWN, 601)) STAT_KWN FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK INNER JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK, PRINTED_DATE,PRINTED_BY FROM (SELECT NIK,PRINTED_DATE,PRINTED_BY, RANK() OVER (PARTITION BY NIK ORDER BY PRINTED_DATE DESC) RNK FROM T7_HIST_SUKET) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (B.CURRENT_STATUS_CODE NOT LIKE '%CARD%' AND B.CURRENT_STATUS_CODE NOT LIKE '%PRINT%') AND (A.REQ_DATE > C.PRINTED_DATE OR C.PRINTED_DATE IS NULL)";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->db->query($sql);
			return $q->result();
		}

		public function cek_req_count_usuket($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT COUNT(X.NIK) AS JML FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP  WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK INNER JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK, PRINTED_DATE,PRINTED_BY FROM (SELECT NIK,PRINTED_DATE,PRINTED_BY, RANK() OVER (PARTITION BY NIK ORDER BY PRINTED_DATE DESC) RNK FROM T7_HIST_SUKET) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (B.CURRENT_STATUS_CODE NOT LIKE '%CARD%' AND B.CURRENT_STATUS_CODE NOT LIKE '%PRINT%') AND (A.REQ_DATE > C.PRINTED_DATE OR C.PRINTED_DATE IS NULL)";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->db->query($sql);
			return $q->row(0)->JML;
		}

		public function cek_req_data_dsuket($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT X.NO_KEC,X.NIK,X.NAMA_LGKP AS NAMA_LENGKAP,B.CURRENT_STATUS_CODE,TO_CHAR(A.REQ_DATE,'DD-MM-YYYY') AS REQ_DATE,A.REQ_BY, TO_CHAR(C.PRINTED_DATE,'DD-MM-YYYY') AS PRINTED_DATE,C.PRINTED_BY, F5_GET_NAMA_KECAMATAN(A.NO_PROP,A.NO_KAB,A.NO_KEC) NAMA_KEC, F5_GET_NAMA_KELURAHAN(A.NO_PROP,A.NO_KAB,A.NO_KEC,A.NO_KEL) NAMA_KEL, UPPER(F5_GET_REF_WNI(X.JENIS_PKRJN, 201)) JENIS_PKRJN, UPPER(F5_GET_REF_WNI(X.STAT_KWN, 601)) STAT_KWN FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP  WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK INNER JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK, PRINTED_DATE,PRINTED_BY FROM (SELECT NIK,PRINTED_DATE,PRINTED_BY, RANK() OVER (PARTITION BY NIK ORDER BY PRINTED_DATE DESC) RNK FROM T7_HIST_SUKET) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (B.CURRENT_STATUS_CODE NOT LIKE '%CARD%' AND B.CURRENT_STATUS_CODE NOT LIKE '%PRINT%') AND (A.REQ_DATE < C.PRINTED_DATE)";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->db->query($sql);
			return $q->result();
		}

		public function cek_req_count_dsuket($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT COUNT(X.NIK) AS JML FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC,NO_KEL, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP  WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK INNER JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN (SELECT NIK, PRINTED_DATE,PRINTED_BY FROM (SELECT NIK,PRINTED_DATE,PRINTED_BY, RANK() OVER (PARTITION BY NIK ORDER BY PRINTED_DATE DESC) RNK FROM T7_HIST_SUKET) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND (B.CURRENT_STATUS_CODE NOT LIKE '%CARD%' AND B.CURRENT_STATUS_CODE NOT LIKE '%PRINT%') AND (A.REQ_DATE < C.PRINTED_DATE)";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->db->query($sql);
			return $q->row(0)->JML;
		}
		public function cek_req_data_bio($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT X.NO_KEC,X.NIK,X.NAMA_LGKP AS NAMA_LENGKAP, CASE WHEN B.CURRENT_STATUS_CODE IS NULL THEN 'REQ BIO' ELSE B.CURRENT_STATUS_CODE END AS CURRENT_STATUS_CODE,TO_CHAR(A.REQ_DATE,'DD-MM-YYYY') AS REQ_DATE,A.REQ_BY, TO_CHAR(C.CREATED,'DD-MM-YYYY') AS PRINTED_DATE,C.CREATED_USERNAME AS PRINTED_BY FROM BIODATA_WNI X INNER JOIN (SELECT ID_CETAK,NO_KEC, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK LEFT JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN DEMOGRAPHICS@DB2 D ON A.NIK = D.NIK LEFT JOIN (SELECT NIK,CREATED,CREATED_USERNAME FROM (SELECT NIK,CREATED,CREATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY CREATED DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND ((B.CURRENT_STATUS_CODE IS NULL) AND (D.CURRENT_STATUS_CODE IS NULL))";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";			
			$q = $this->db->query($sql);
			return $q->result();
		}

		public function cek_req_count_bio($nik,$tgl_start,$tgl_end,$no_kec,$no_kel){
			$sql = "";
			$sql .= "SELECT COUNT(X.NIK) AS JML FROM BIODATA_WNI X INNER JOIN  (SELECT ID_CETAK,NO_KEC, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY FROM (SELECT  ID_CETAK, NO_KEC, NIK,NAMA_LENGKAP,REQ_DATE,REQ_BY, RANK() OVER (PARTITION BY NIK ORDER BY ID_CETAK DESC) RNK FROM T5_REQ_CETAK_KTP WHERE STEP_PROC = 'A') WHERE RNK = 1) A ON A.NIK = X.NIK LEFT JOIN DEMOGRAPHICS_ALL@DB2 B ON A.NIK = B.NIK LEFT JOIN DEMOGRAPHICS@DB2 D ON A.NIK = D.NIK LEFT JOIN (SELECT NIK,CREATED,CREATED_USERNAME FROM (SELECT NIK,CREATED,CREATED_USERNAME, RANK() OVER (PARTITION BY NIK ORDER BY CREATED DESC) RNK FROM CARD_MANAGEMENT@DB2) WHERE RNK = 1) C ON A.NIK = C.NIK  WHERE 1=1 AND ((B.CURRENT_STATUS_CODE IS NULL) AND (D.CURRENT_STATUS_CODE IS NULL))";
			if($no_kec != 0){
				$sql .= " AND X.NO_KEC = $no_kec";
			}
			if($no_kel != 0){
				$sql .= " AND X.NO_KEL = $no_kel";
			} 
			if($nik != ""){
				$sql .= " AND X.NIK IN ($nik)";
			}
			$sql .= " AND A.REQ_DATE >= TO_DATE('$tgl_start','DD-MM-YYYY') AND A.REQ_DATE < TO_DATE('$tgl_end','DD-MM-YYYY') +1";
			$q = $this->db->query($sql);
			return $q->row(0)->JML;
		}
		function get_no_prop()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_no_prop();
    	}
    	function get_no_kab()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_no_kab();
    	}
    	function get_siak_dblink()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_siak_dblink();
    	}
    	function get_rekam_dblink()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_rekam_dblink();
    	}
    	function get_cetak_dblink()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_cetak_dblink();
    	}
    	function get_master_dblink()
    	{
         $CI =& get_instance();
         $CI->load->model('M_Shared');
         return $CI->M_Shared->get_master_dblink();
    	}
}